List models
GET /v1/models
Lists all language models that are available for use with the service. The information includes the name of the model and its minimum sampling rate in Hertz, among other things. The ordering of the list of models can change from call to call; do not rely on an alphabetized or static list of models.
See also: Listing all models.
Request
Response
200 - OK. The request succeeded.
models
array
An array of `SpeechModel` objects that provides information about each available model.
406 - Not Acceptable. The request specified an `Accept` header with an incompatible content type.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
415 - Unsupported Media Type. The request specified an unacceptable media type.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
500 - Internal Server Error. The service experienced an internal error.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
503 - Service Unavailable. The service is currently unavailable.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
Get a model
GET /v1/models/{model_id}
Gets information for a single specified language model that is available for use with the service. The information includes the name of the model and its minimum sampling rate in Hertz, among other things.
See also: Listing a specific model.
Request
Path Parameters
model_id
Required *
string
The identifier of the model in the form of its name from the output of the List models method.
Query Parameters
Response
200 - OK. The request succeeded.
name
string
The name of the model for use as an identifier in calls to the service (for example, `en-US_BroadbandModel`).
language
string
The language identifier of the model (for example, `en-US`).
rate
integer
The sampling rate (minimum acceptable rate for audio) used by the model in Hertz.
url
string
The URI for the model.
supported_features
SupportedFeatures
Indicates whether select service features are supported with the model.
description
string
A brief description of the model.
404 - Not Found. The specified `model_id` was not found.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
406 - Not Acceptable. The request specified an `Accept` header with an incompatible content type.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
415 - Unsupported Media Type. The request specified an unacceptable media type.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
500 - Internal Server Error. The service experienced an internal error.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
503 - Service Unavailable. The service is currently unavailable.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
Streaming mode
For requests to transcribe live audio as it becomes available, you must set the `Transfer-Encoding` header to `chunked` to use streaming mode. In streaming mode, the service closes the connection (status code 408) if it does not receive at least 15 seconds of audio (including silence) in any 30-second period. The service also closes the connection (status code 400) if it detects no speech for `inactivity_timeout` seconds of streaming audio; use the `inactivity_timeout` parameter to change the default of 30 seconds.
See also:
Audio formats (content types)
The service accepts audio in the following formats (MIME types).
- For formats that are labeled Required, you must use the `Content-Type` header with the request to specify the format of the audio.
- For all other formats, you can omit the `Content-Type` header or specify `application/octet-stream` with the header to have the service automatically detect the format of the audio. (With the `curl` command, you can specify either `"Content-Type:"` or `"Content-Type: application/octet-stream"`.)
Where indicated, the format that you specify must include the sampling rate and can optionally include the number of channels and the endianness of the audio.
- `audio/alaw` (Required. Specify the sampling rate (`rate`) of the audio.)
- `audio/basic` (Required. Use only with narrowband models.)
- `audio/flac`
- `audio/g729` (Use only with narrowband models.)
- `audio/l16` (Required. Specify the sampling rate (`rate`) and optionally the number of channels (`channels`) and endianness (`endianness`) of the audio.)
- `audio/mp3`
- `audio/mpeg`
- `audio/mulaw` (Required. Specify the sampling rate (`rate`) of the audio.)
- `audio/ogg` (The service automatically detects the codec of the input audio.)
- `audio/ogg;codecs=opus`
- `audio/ogg;codecs=vorbis`
- `audio/wav` (Provide audio with a maximum of nine channels.)
- `audio/webm` (The service automatically detects the codec of the input audio.)
- `audio/webm;codecs=opus`
- `audio/webm;codecs=vorbis`
The sampling rate of the audio must match the sampling rate of the model for the recognition request: for broadband models, at least 16 kHz; for narrowband models, at least 8 kHz. If the sampling rate of the audio is higher than the minimum required rate, the service down-samples the audio to the appropriate rate. If the sampling rate of the audio is lower than the minimum required rate, the request fails.
See also: Supported audio formats.
Large speech models and Next-generation models
The service supports large speech models and next-generation `Multimedia` (16 kHz) and `Telephony` (8 kHz) models for many languages. Large speech models and next-generation models have higher throughput than the service's previous generation of `Broadband` and `Narrowband` models. When you use large speech models and next-generation models, the service can return transcriptions more quickly and also provide noticeably better transcription accuracy.
You specify a large speech model or next-generation model by using the `model` query parameter, as you do a previous-generation model. Only the next-generation models support the `low_latency` parameter, and all large speech models and next-generation models support the `character_insertion_bias` parameter. These parameters are not available with previous-generation models.
Large speech models and next-generation models do not support all of the speech recognition parameters that are available for use with previous-generation models. Next-generation models do not support the following parameters:
- `acoustic_customization_id`
- `keywords` and `keywords_threshold`
- `processing_metrics` and `processing_metrics_interval`
- `word_alternatives_threshold`
Important: Effective 31 July 2023, all previous-generation models will be removed from the service and the documentation. Most previous-generation models were deprecated on 15 March 2022. You must migrate to the equivalent large speech model or next-generation model by 31 July 2023. For more information, see Migrating to large speech models.
See also:
- Large speech languages and models
- Supported features for large speech models
- Next-generation languages and models
- Supported features for next-generation models
Multipart speech recognition
Note: The asynchronous HTTP interface, WebSocket interface, and Watson SDKs do not support multipart speech recognition.
The HTTP `POST` method of the service also supports multipart speech recognition. With multipart requests, you pass all audio data as multipart form data. You specify some parameters as request headers and query parameters, but you pass JSON metadata as form data to control most aspects of the transcription. You can use multipart recognition to pass multiple audio files with a single request.
Use the multipart approach with browsers for which JavaScript is disabled or when the parameters used with the request are greater than the 8 KB limit imposed by most HTTP servers and proxies. You can encounter this limit, for example, if you want to spot a very large number of keywords.
See also: Making a multipart HTTP request.">
Recognize audio
POST /v1/recognize
Sends audio and returns transcription results for a recognition request. You can pass a maximum of 100 MB and a minimum of 100 bytes of audio with a request. The service automatically detects the endianness of the incoming audio and, for audio that includes multiple channels, downmixes the audio to one-channel mono during transcoding. The method returns only final results; to enable interim results, use the WebSocket API. (With the `curl` command, use the `--data-binary` option to upload the file for the request.)
See also: Making a basic HTTP request.
Streaming mode
For requests to transcribe live audio as it becomes available, you must set the `Transfer-Encoding` header to `chunked` to use streaming mode. In streaming mode, the service closes the connection (status code 408) if it does not receive at least 15 seconds of audio (including silence) in any 30-second period. The service also closes the connection (status code 400) if it detects no speech for `inactivity_timeout` seconds of streaming audio; use the `inactivity_timeout` parameter to change the default of 30 seconds.
See also:
Audio formats (content types)
The service accepts audio in the following formats (MIME types).
- For formats that are labeled Required, you must use the `Content-Type` header with the request to specify the format of the audio.
- For all other formats, you can omit the `Content-Type` header or specify `application/octet-stream` with the header to have the service automatically detect the format of the audio. (With the `curl` command, you can specify either `"Content-Type:"` or `"Content-Type: application/octet-stream"`.)
Where indicated, the format that you specify must include the sampling rate and can optionally include the number of channels and the endianness of the audio.
- `audio/alaw` (Required. Specify the sampling rate (`rate`) of the audio.)
- `audio/basic` (Required. Use only with narrowband models.)
- `audio/flac`
- `audio/g729` (Use only with narrowband models.)
- `audio/l16` (Required. Specify the sampling rate (`rate`) and optionally the number of channels (`channels`) and endianness (`endianness`) of the audio.)
- `audio/mp3`
- `audio/mpeg`
- `audio/mulaw` (Required. Specify the sampling rate (`rate`) of the audio.)
- `audio/ogg` (The service automatically detects the codec of the input audio.)
- `audio/ogg;codecs=opus`
- `audio/ogg;codecs=vorbis`
- `audio/wav` (Provide audio with a maximum of nine channels.)
- `audio/webm` (The service automatically detects the codec of the input audio.)
- `audio/webm;codecs=opus`
- `audio/webm;codecs=vorbis`
The sampling rate of the audio must match the sampling rate of the model for the recognition request: for broadband models, at least 16 kHz; for narrowband models, at least 8 kHz. If the sampling rate of the audio is higher than the minimum required rate, the service down-samples the audio to the appropriate rate. If the sampling rate of the audio is lower than the minimum required rate, the request fails.
See also: Supported audio formats.
Large speech models and Next-generation models
The service supports large speech models and next-generation `Multimedia` (16 kHz) and `Telephony` (8 kHz) models for many languages. Large speech models and next-generation models have higher throughput than the service's previous generation of `Broadband` and `Narrowband` models. When you use large speech models and next-generation models, the service can return transcriptions more quickly and also provide noticeably better transcription accuracy.
You specify a large speech model or next-generation model by using the `model` query parameter, as you do a previous-generation model. Only the next-generation models support the `low_latency` parameter, and all large speech models and next-generation models support the `character_insertion_bias` parameter. These parameters are not available with previous-generation models.
Large speech models and next-generation models do not support all of the speech recognition parameters that are available for use with previous-generation models. Next-generation models do not support the following parameters:
- `acoustic_customization_id`
- `keywords` and `keywords_threshold`
- `processing_metrics` and `processing_metrics_interval`
- `word_alternatives_threshold`
Important: Effective 31 July 2023, all previous-generation models will be removed from the service and the documentation. Most previous-generation models were deprecated on 15 March 2022. You must migrate to the equivalent large speech model or next-generation model by 31 July 2023. For more information, see Migrating to large speech models.
See also:
- Large speech languages and models
- Supported features for large speech models
- Next-generation languages and models
- Supported features for next-generation models
Multipart speech recognition
Note: The asynchronous HTTP interface, WebSocket interface, and Watson SDKs do not support multipart speech recognition.
The HTTP `POST` method of the service also supports multipart speech recognition. With multipart requests, you pass all audio data as multipart form data. You specify some parameters as request headers and query parameters, but you pass JSON metadata as form data to control most aspects of the transcription. You can use multipart recognition to pass multiple audio files with a single request.
Use the multipart approach with browsers for which JavaScript is disabled or when the parameters used with the request are greater than the 8 KB limit imposed by most HTTP servers and proxies. You can encounter this limit, for example, if you want to spot a very large number of keywords.
See also: Making a multipart HTTP request.
Request
Request Body
Path Parameters
Query Parameters
model
string
The model to use for speech recognition. If you omit the `model` parameter, the service uses the US English `en-US_BroadbandModel` by default.
For IBM Cloud Pak for Data, if you do not install the `en-US_BroadbandModel`, you must either specify a model with the request or specify a new default model for your installation of the service.
See also:
speech_begin_event
boolean
If `true`, the service returns a response object `SpeechActivity` which contains the time when a speech activity is detected in the stream. This can be used both in standard and low latency mode. This feature enables client applications to know that some words/speech has been detected and the service is in the process of decoding. This can be used in lieu of interim results in standard mode. Use `sad_module: 2` to increase accuracy and performance in detecting speech boundaries within the audio stream. See Using speech recognition parameters
enrichments
string
Speech transcript enrichment improves readability of raw ASR transcripts by adding punctuation (periods, commas, question marks, exclamation points) and intelligent capitalization (sentence beginnings, proper nouns, acronyms, brand names). To enable enrichment, add the `enrichments=punctuation` parameter to your recognition request. Supported languages include English (US, UK, Australia, India), French (France, Canada), German, Italian, Portuguese (Brazil, Portugal), Spanish (Spain, Latin America, Argentina, Chile, Colombia, Mexico, Peru), and Japanese. See Speech transcript enrichment.
language_customization_id
string
The customization ID (GUID) of a custom language model that is to be used with the recognition request. The base model of the specified custom language model must match the model specified with the `model` parameter. You must make the request with credentials for the instance of the service that owns the custom model. By default, no custom language model is used. See Using a custom language model for speech recognition.
Note: Use this parameter instead of the deprecated `customization_id` parameter.
acoustic_customization_id
string
The customization ID (GUID) of a custom acoustic model that is to be used with the recognition request. The base model of the specified custom acoustic model must match the model specified with the `model` parameter. You must make the request with credentials for the instance of the service that owns the custom model. By default, no custom acoustic model is used. See Using a custom acoustic model for speech recognition.
base_model_version
string
The version of the specified base model that is to be used with the recognition request. Multiple versions of a base model can exist when a model is updated for internal improvements. The parameter is intended primarily for use with custom models that have been upgraded for a new base model. The default value depends on whether the parameter is used with or without a custom model. See Making speech recognition requests with upgraded custom models.
customization_weight
number
If you specify the customization ID (GUID) of a custom language model with the recognition request, the customization weight tells the service how much weight to give to words from the custom language model compared to those from the base model for the current request.
Specify a value between 0.0 and 1.0. Unless a different customization weight was specified for the custom model when the model was trained, the default value is:
- 0.5 for large speech models
- 0.3 for previous-generation models
- 0.2 for most next-generation models
- 0.1 for next-generation English and Japanese models
A customization weight that you specify overrides a weight that was specified when the custom model was trained. The default value yields the best performance in general. Assign a higher value if your audio makes frequent use of OOV words from the custom model. Use caution when setting the weight: a higher value can improve the accuracy of phrases from the custom model's domain, but it can negatively affect performance on non-domain phrases.
See Using customization weight.
inactivity_timeout
integer
The time in seconds after which, if only silence (no speech) is detected in streaming audio, the connection is closed with a 400 error. The parameter is useful for stopping audio submission from a live microphone when a user simply walks away. Use `-1` for infinity. See Inactivity timeout.
keywords
array
An array of keyword strings to spot in the audio. Each keyword string can include one or more string tokens. Keywords are spotted only in the final results, not in interim hypotheses. If you specify any keywords, you must also specify a keywords threshold. Omit the parameter or specify an empty array if you do not need to spot keywords.
You can spot a maximum of 1000 keywords with a single request. A single keyword can have a maximum length of 1024 characters, though the maximum effective length for double-byte languages might be shorter. Keywords are case-insensitive.
See Keyword spotting.
keywords_threshold
number
A confidence value that is the lower bound for spotting a keyword. A word is considered to match a keyword if its confidence is greater than or equal to the threshold. Specify a probability between 0.0 and 1.0. If you specify a threshold, you must also specify one or more keywords. The service performs no keyword spotting if you omit either parameter. See Keyword spotting.
max_alternatives
integer
The maximum number of alternative transcripts that the service is to return. By default, the service returns a single transcript. If you specify a value of `0`, the service uses the default value, `1`. See Maximum alternatives.
word_alternatives_threshold
number
A confidence value that is the lower bound for identifying a hypothesis as a possible word alternative (also known as "Confusion Networks"). An alternative word is considered if its confidence is greater than or equal to the threshold. Specify a probability between 0.0 and 1.0. By default, the service computes no alternative words. See Word alternatives.
word_confidence
boolean
If `true`, the service returns a confidence measure in the range of 0.0 to 1.0 for each word. By default, the service returns no word confidence scores. See Word confidence.
timestamps
boolean
If `true`, the service returns time alignment for each word. By default, no timestamps are returned. See Word timestamps.
profanity_filter
boolean
If `true`, the service filters profanity from all output except for keyword results by replacing inappropriate words with a series of asterisks. Set the parameter to `false` to return results with no censoring.
Note: The parameter can be used with US English and Japanese transcription only. See Profanity filtering.
smart_formatting
boolean
If `true`, the service converts dates, times, series of digits and numbers, phone numbers, currency values, and internet addresses into more readable, conventional representations in the final transcript of a recognition request. For US English, the service also converts certain keyword strings to punctuation symbols. By default, the service performs no smart formatting.
Note: The parameter can be used with US English, Japanese, and Spanish (all dialects) transcription only.
See Smart formatting.
smart_formatting_version
integer
Smart formatting version for large speech models and next-generation models is supported in US English, Brazilian Portuguese, French, German, Spanish and French Canadian languages.
speaker_labels
boolean
If `true`, the response includes labels that identify which words were spoken by which participants in a multi-person exchange. By default, the service returns no speaker labels. Setting `speaker_labels` to `true` forces the `timestamps` parameter to be `true`, regardless of whether you specify `false` for the parameter.
- For previous-generation models, the parameter can be used with Australian English, US English, German, Japanese, Korean, and Spanish (both broadband and narrowband models) and UK English (narrowband model) transcription only.
- For large speech models and next-generation models, the parameter can be used with all available languages.
See Speaker labels.
grammar_name
string
The name of a grammar that is to be used with the recognition request. If you specify a grammar, you must also use the `language_customization_id` parameter to specify the name of the custom language model for which the grammar is defined. The service recognizes only strings that are recognized by the specified grammar; it does not recognize other custom words from the model's words resource.
See Using a grammar for speech recognition.
redaction
boolean
If `true`, the service redacts, or masks, numeric data from final transcripts. The feature redacts any number that has three or more consecutive digits by replacing each digit with an `X` character. It is intended to redact sensitive numeric data, such as credit card numbers. By default, the service performs no redaction.
When you enable redaction, the service automatically enables smart formatting, regardless of whether you explicitly disable that feature. To ensure maximum security, the service also disables keyword spotting (ignores the `keywords` and `keywords_threshold` parameters) and returns only a single final transcript (forces the `max_alternatives` parameter to be `1`).
Note: The parameter can be used with US English, Japanese, and Korean transcription only.
See Numeric redaction.
audio_metrics
boolean
If `true`, requests detailed information about the signal characteristics of the input audio. The service returns audio metrics with the final transcription results. By default, the service returns no audio metrics.
See Audio metrics.
end_of_phrase_silence_time
number
Specifies the duration of the pause interval at which the service splits a transcript into multiple final results. If the service detects pauses or extended silence before it reaches the end of the audio stream, its response can include multiple final results. Silence indicates a point at which the speaker pauses between spoken words or phrases.
Specify a value for the pause interval in the range of 0.0 to 120.0.
- A value greater than 0 specifies the interval that the service is to use for speech recognition.
- A value of 0 indicates that the service is to use the default interval. It is equivalent to omitting the parameter.
The default pause interval for most languages is 0.8 seconds; the default for Chinese is 0.6 seconds.
See End of phrase silence time.
split_transcript_at_phrase_end
boolean
If `true`, directs the service to split the transcript into multiple final results based on semantic features of the input, for example, at the conclusion of meaningful phrases such as sentences. The service bases its understanding of semantic features on the base language model that you use with a request. Custom language models and grammars can also influence how and where the service splits a transcript.
By default, the service splits transcripts based solely on the pause interval. If the parameters are used together on the same request, `end_of_phrase_silence_time` has precedence over `split_transcript_at_phrase_end`.
See Split transcript at phrase end.
speech_detector_sensitivity
number
The sensitivity of speech activity detection that the service is to perform. Use the parameter to suppress word insertions from music, coughing, and other non-speech events. The service biases the audio it passes for speech recognition by evaluating the input audio against prior models of speech and non-speech activity.
Specify a value between 0.0 and 1.0:
- 0.0 suppresses all audio (no speech is transcribed).
- 0.5 (the default) provides a reasonable compromise for the level of sensitivity.
- 1.0 suppresses no audio (speech detection sensitivity is disabled).
The values increase on a monotonic curve. Specifying one or two decimal places of precision (for example, `0.55`) is typically more than sufficient.
The parameter is supported with all large speech models, next-generation models and with most previous-generation models. See Speech detector sensitivity and Language model support.
sad_module
integer
Detects speech boundaries within the audio stream with better performance, improved noise suppression, faster responsiveness, and increased accuracy.
Specify `sad_module: 2`
See Speech Activity Detection (SAD).
background_audio_suppression
number
The level to which the service is to suppress background audio based on its volume to prevent it from being transcribed as speech. Use the parameter to suppress side conversations or background noise.
Specify a value in the range of 0.0 to 1.0:
- 0.0 (the default) provides no suppression (background audio suppression is disabled).
- 0.5 provides a reasonable level of audio suppression for general usage.
- 1.0 suppresses all audio (no audio is transcribed).
The values increase on a monotonic curve. Specifying one or two decimal places of precision (for example, `0.55`) is typically more than sufficient.
The parameter is supported with all large speech models, next-generation models and with most previous-generation models. See Background audio suppression and Language model support.
low_latency
boolean
If `true` for next-generation `Multimedia` and `Telephony` models that support low latency, directs the service to produce results even more quickly than it usually does. Next-generation models produce transcription results faster than previous-generation models. The `low_latency` parameter causes the models to produce results even more quickly, though the results might be less accurate when the parameter is used.
The parameter is not available for large speech models and previous-generation `Broadband` and `Narrowband` models. It is available for most next-generation models.
- For a list of next-generation models that support low latency, see Supported next-generation language models.
- For more information about the `low_latency` parameter, see Low latency.
character_insertion_bias
number
For large speech models and next-generation models, an indication of whether the service is biased to recognize shorter or longer strings of characters when developing transcription hypotheses. By default, the service is optimized to produce the best balance of strings of different lengths.
The default bias is 0.0. The allowable range of values is -1.0 to 1.0.
- Negative values bias the service to favor hypotheses with shorter strings of characters.
- Positive values bias the service to favor hypotheses with longer strings of characters.
As the value approaches -1.0 or 1.0, the impact of the parameter becomes more pronounced. To determine the most effective value for your scenario, start by setting the value of the parameter to a small increment, such as -0.1, -0.05, 0.05, or 0.1, and assess how the value impacts the transcription results. Then experiment with different values as necessary, adjusting the value by small increments.
The parameter is not available for previous-generation models.
Response
200 - OK. The request succeeded.
results
array
An array of `SpeechRecognitionResult` objects that can include interim and final results (interim results are returned only if supported by the method). Final results are guaranteed not to change; interim results might be replaced by further interim results and eventually final results.
For the HTTP interfaces, all results arrive at the same time. For the WebSocket interface, results can be sent as multiple separate responses. The service periodically sends updates to the results list. The `result_index` is incremented to the lowest index in the array that has changed for new results.
For more information, see Understanding speech recognition results.
result_index
integer
An index that indicates a change point in the `results` array. The service increments the index for additional results that it sends for new audio for the same request. All results with the same index are delivered at the same time. The same index can include multiple final results that are delivered with the same response.
speaker_labels
array
An array of `SpeakerLabelsResult` objects that identifies which words were spoken by which speakers in a multi-person exchange. The array is returned only if the `speaker_labels` parameter is `true`. When interim results are also requested for methods that support them, it is possible for a `SpeechRecognitionResults` object to include only the `speaker_labels` field.
processing_metrics
ProcessingMetrics
If processing metrics are requested, information about the service's processing of the input audio. Processing metrics are not available with the synchronous Recognize audio method.
audio_metrics
AudioMetrics
If audio metrics are requested, information about the signal characteristics of the input audio.
warnings
array
An array of warning messages associated with the request:
- Warnings for invalid parameters or fields can include a descriptive message and a list of invalid argument strings, for example, `"Unknown arguments:"` or `"Unknown url query arguments:"` followed by a list of the form `"{invalid_arg_1}, {invalid_arg_2}."` (If you use the `character_insertion_bias` parameter with a previous-generation model, the warning message refers to the parameter as `lambdaBias`.)
- The following warning is returned if the request passes a custom model that is based on an older version of a base model for which an updated version is available: `"Using previous version of base model, because your custom model has been built with it. Please note that this version will be supported only for a limited time. Consider updating your custom model to the new base model. If you do not do that you will be automatically switched to base model when you used the non-updated custom model."`
In both cases, the request succeeds despite the warnings.
enriched_results
EnrichedResults
If enriched results are requested, transcription with inserted punctuation marks such as periods, commas, question marks, and exclamation points.
400 - Bad Request. The request failed because of a user input error. For example, the request passed audio that does not match the indicated format or failed to specify a required audio format; specified a custom language or custom acoustic model that is not in the `available` state; or experienced an inactivity timeout. Specific messages include
- `Model {model} not found`
- `Requested model is not available`
- `This 8000hz audio input requires a narrow band model. See /v1/models for a listp of available models.`
- `speaker_labels is not a supported feature for model {model}`
- `keywords_threshold value must be between zero and one (inclusive)`
- `word_alternatives_threshold value must be between zero and one (inclusive)`
- `You cannot specify both 'customization_id' and 'language_customization_id' parameter!`
- `No speech detected for 30s`
- `Unable to transcode data stream application/octet-stream -> audio/l16`
- `Stream was {number} bytes but needs to be at least 100 bytes.`
- `keyword {keyword} length exceeds the maximum length 1024`
- `low_latency is not a supported feature for model {model}`
- `Character insertion bias must be a value between -1 and 1.`
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
404 - Not Found. The specified model does not exist or, for IBM Cloud Pak for Data, the `model` parameter was not specified but the default model is not installed. The message is `Model '{model}' not found`.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
406 - Not Acceptable. The request specified an `Accept` header with an incompatible content type.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
408 - Request Timeout. The connection was closed due to inactivity (session timeout) for 30 seconds.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
413 - Payload Too Large. The request passed an audio file that exceeded the currently supported data limit.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
415 - Unsupported Media Type. The request specified an unacceptable media type.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
500 - Internal Server Error. The service experienced an internal error.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
503 - Service Unavailable. The service is currently unavailable.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
Register a callback
POST /v1/register_callback
Registers a callback URL with the service for use with subsequent asynchronous recognition requests. The service attempts to register, or allowlist, the callback URL if it is not already registered by sending a `GET` request to the callback URL. The service passes a random alphanumeric challenge string via the `challenge_string` parameter of the request. The request includes an `Accept` header that specifies `text/plain` as the required response type.
To be registered successfully, the callback URL must respond to the `GET` request from the service. The response must send status code 200 and must include the challenge string in its body. Set the `Content-Type` response header to `text/plain`. Upon receiving this response, the service responds to the original registration request with response code 201.
The service sends only a single `GET` request to the callback URL. If the service does not receive a reply with a response code of 200 and a body that echoes the challenge string sent by the service within five seconds, it does not allowlist the URL; it instead sends status code 400 in response to the request to register a callback. If the requested callback URL is already allowlisted, the service responds to the initial registration request with response code 200.
If you specify a user secret with the request, the service uses it as a key to calculate an HMAC-SHA1 signature of the challenge string in its response to the `POST` request. It sends this signature in the `X-Callback-Signature` header of its `GET` request to the URL during registration. It also uses the secret to calculate a signature over the payload of every callback notification that uses the URL. The signature provides authentication and data integrity for HTTP communications.
After you successfully register a callback URL, you can use it with an indefinite number of recognition requests. You can register a maximum of 20 callback URLS in a one-hour span of time.
See also: Registering a callback URL.
Request
Path Parameters
Query Parameters
callback_url
Required *
string
An HTTP or HTTPS URL to which callback notifications are to be sent. To be allowlisted, the URL must successfully echo the challenge string during URL verification. During verification, the client can also check the signature that the service sends in the `X-Callback-Signature` header to verify the origin of the request.
user_secret
string
A user-specified string that the service uses to generate the HMAC-SHA1 signature that it sends via the `X-Callback-Signature` header. The service includes the header during URL verification and with every notification sent to the callback URL. It calculates the signature over the payload of the notification. If you omit the parameter, the service does not send the header.
Response
200 - OK. The callback was already registered (allowlisted). The status included in the response is `already created`.
status
string
The current status of the job:
- `created`: The service successfully allowlisted the callback URL as a result of the call.
- `already created`: The URL was already allowlisted.
url
string
The callback URL that is successfully registered.
201 - Created. The callback was successfully registered (allowlisted). The status included in the response is `created`.
status
string
The current status of the job:
- `created`: The service successfully allowlisted the callback URL as a result of the call.
- `already created`: The URL was already allowlisted.
url
string
The callback URL that is successfully registered.
400 - Bad Request. The callback registration failed. The request was missing a required parameter or specified an invalid argument; the client sent an invalid response to the service's `GET` request during the registration process; or the client failed to respond to the server's request before the five-second timeout.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
500 - Internal Server Error. The service experienced an internal error.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
503 - Service Unavailable. The service is currently unavailable.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
Unregister a callback
POST /v1/unregister_callback
Unregisters a callback URL that was previously allowlisted with a Register a callback request for use with the asynchronous interface. Once unregistered, the URL can no longer be used with asynchronous recognition requests.
See also: Unregistering a callback URL.
Request
Path Parameters
Query Parameters
callback_url
Required *
string
The callback URL that is to be unregistered.
Response
200 - OK. The callback URL was successfully unregistered.
400 - Bad Request. The request failed because of a user input error (for example, because it failed to pass a callback URL).
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
404 - Not Found. The specified callback URL was not found.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
500 - Internal Server Error. The service experienced an internal error.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
503 - Service Unavailable. The service is currently unavailable.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
The method supports the same basic parameters as other HTTP and WebSocket recognition requests. It also supports the following parameters specific to the asynchronous interface:
- `callback_url`
- `events`
- `user_token`
- `results_ttl`
You can pass a maximum of 1 GB and a minimum of 100 bytes of audio with a request. The service automatically detects the endianness of the incoming audio and, for audio that includes multiple channels, downmixes the audio to one-channel mono during transcoding. The method returns only final results; to enable interim results, use the WebSocket API. (With the `curl` command, use the `--data-binary` option to upload the file for the request.)
See also: Creating a job.
Streaming mode
For requests to transcribe live audio as it becomes available, you must set the `Transfer-Encoding` header to `chunked` to use streaming mode. In streaming mode, the service closes the connection (status code 408) if it does not receive at least 15 seconds of audio (including silence) in any 30-second period. The service also closes the connection (status code 400) if it detects no speech for `inactivity_timeout` seconds of streaming audio; use the `inactivity_timeout` parameter to change the default of 30 seconds.
See also:
Audio formats (content types)
The service accepts audio in the following formats (MIME types).
- For formats that are labeled Required, you must use the `Content-Type` header with the request to specify the format of the audio.
- For all other formats, you can omit the `Content-Type` header or specify `application/octet-stream` with the header to have the service automatically detect the format of the audio. (With the `curl` command, you can specify either `"Content-Type:"` or `"Content-Type: application/octet-stream"`.)
Where indicated, the format that you specify must include the sampling rate and can optionally include the number of channels and the endianness of the audio.
- `audio/alaw` (Required. Specify the sampling rate (`rate`) of the audio.)
- `audio/basic` (Required. Use only with narrowband models.)
- `audio/flac`
- `audio/g729` (Use only with narrowband models.)
- `audio/l16` (Required. Specify the sampling rate (`rate`) and optionally the number of channels (`channels`) and endianness (`endianness`) of the audio.)
- `audio/mp3`
- `audio/mpeg`
- `audio/mulaw` (Required. Specify the sampling rate (`rate`) of the audio.)
- `audio/ogg` (The service automatically detects the codec of the input audio.)
- `audio/ogg;codecs=opus`
- `audio/ogg;codecs=vorbis`
- `audio/wav` (Provide audio with a maximum of nine channels.)
- `audio/webm` (The service automatically detects the codec of the input audio.)
- `audio/webm;codecs=opus`
- `audio/webm;codecs=vorbis`
The sampling rate of the audio must match the sampling rate of the model for the recognition request: for broadband models, at least 16 kHz; for narrowband models, at least 8 kHz. If the sampling rate of the audio is higher than the minimum required rate, the service down-samples the audio to the appropriate rate. If the sampling rate of the audio is lower than the minimum required rate, the request fails.
See also: Supported audio formats.
Large speech models and Next-generation models
The service supports large speech models and next-generation `Multimedia` (16 kHz) and `Telephony` (8 kHz) models for many languages. Large speech models and next-generation models have higher throughput than the service's previous generation of `Broadband` and `Narrowband` models. When you use large speech models and next-generation models, the service can return transcriptions more quickly and also provide noticeably better transcription accuracy.
You specify a large speech model or next-generation model by using the `model` query parameter, as you do a previous-generation model. Only the next-generation models support the `low_latency` parameter, and all large speech models and next-generation models support the `character_insertion_bias` parameter. These parameters are not available with previous-generation models.
Large speech models and next-generation models do not support all of the speech recognition parameters that are available for use with previous-generation models. Next-generation models do not support the following parameters:
- `acoustic_customization_id`
- `keywords` and `keywords_threshold`
- `processing_metrics` and `processing_metrics_interval`
- `word_alternatives_threshold`
Important: Effective 31 July 2023, all previous-generation models will be removed from the service and the documentation. Most previous-generation models were deprecated on 15 March 2022. You must migrate to the equivalent large speech model or next-generation model by 31 July 2023. For more information, see Migrating to large speech models.
See also:
- Large speech languages and models
- Supported features for large speech models
- Next-generation languages and models
- Supported features for next-generation models">
Create a job
POST /v1/recognitions
Creates a job for a new asynchronous recognition request. The job is owned by the instance of the service whose credentials are used to create it. How you learn the status and results of a job depends on the parameters you include with the job creation request:
- By callback notification: Include the `callback_url` parameter to specify a URL to which the service is to send callback notifications when the status of the job changes. Optionally, you can also include the `events` and `user_token` parameters to subscribe to specific events and to specify a string that is to be included with each notification for the job.
- By polling the service: Omit the `callback_url`, `events`, and `user_token` parameters. You must then use the Check jobs or Check a job methods to check the status of the job, using the latter to retrieve the results when the job is complete.
The two approaches are not mutually exclusive. You can poll the service for job status or obtain results from the service manually even if you include a callback URL. In both cases, you can include the `results_ttl` parameter to specify how long the results are to remain available after the job is complete. Using the HTTPS Check a job method to retrieve results is more secure than receiving them via callback notification over HTTP because it provides confidentiality in addition to authentication and data integrity.
The method supports the same basic parameters as other HTTP and WebSocket recognition requests. It also supports the following parameters specific to the asynchronous interface:
- `callback_url`
- `events`
- `user_token`
- `results_ttl`
You can pass a maximum of 1 GB and a minimum of 100 bytes of audio with a request. The service automatically detects the endianness of the incoming audio and, for audio that includes multiple channels, downmixes the audio to one-channel mono during transcoding. The method returns only final results; to enable interim results, use the WebSocket API. (With the `curl` command, use the `--data-binary` option to upload the file for the request.)
See also: Creating a job.
Streaming mode
For requests to transcribe live audio as it becomes available, you must set the `Transfer-Encoding` header to `chunked` to use streaming mode. In streaming mode, the service closes the connection (status code 408) if it does not receive at least 15 seconds of audio (including silence) in any 30-second period. The service also closes the connection (status code 400) if it detects no speech for `inactivity_timeout` seconds of streaming audio; use the `inactivity_timeout` parameter to change the default of 30 seconds.
See also:
Audio formats (content types)
The service accepts audio in the following formats (MIME types).
- For formats that are labeled Required, you must use the `Content-Type` header with the request to specify the format of the audio.
- For all other formats, you can omit the `Content-Type` header or specify `application/octet-stream` with the header to have the service automatically detect the format of the audio. (With the `curl` command, you can specify either `"Content-Type:"` or `"Content-Type: application/octet-stream"`.)
Where indicated, the format that you specify must include the sampling rate and can optionally include the number of channels and the endianness of the audio.
- `audio/alaw` (Required. Specify the sampling rate (`rate`) of the audio.)
- `audio/basic` (Required. Use only with narrowband models.)
- `audio/flac`
- `audio/g729` (Use only with narrowband models.)
- `audio/l16` (Required. Specify the sampling rate (`rate`) and optionally the number of channels (`channels`) and endianness (`endianness`) of the audio.)
- `audio/mp3`
- `audio/mpeg`
- `audio/mulaw` (Required. Specify the sampling rate (`rate`) of the audio.)
- `audio/ogg` (The service automatically detects the codec of the input audio.)
- `audio/ogg;codecs=opus`
- `audio/ogg;codecs=vorbis`
- `audio/wav` (Provide audio with a maximum of nine channels.)
- `audio/webm` (The service automatically detects the codec of the input audio.)
- `audio/webm;codecs=opus`
- `audio/webm;codecs=vorbis`
The sampling rate of the audio must match the sampling rate of the model for the recognition request: for broadband models, at least 16 kHz; for narrowband models, at least 8 kHz. If the sampling rate of the audio is higher than the minimum required rate, the service down-samples the audio to the appropriate rate. If the sampling rate of the audio is lower than the minimum required rate, the request fails.
See also: Supported audio formats.
Large speech models and Next-generation models
The service supports large speech models and next-generation `Multimedia` (16 kHz) and `Telephony` (8 kHz) models for many languages. Large speech models and next-generation models have higher throughput than the service's previous generation of `Broadband` and `Narrowband` models. When you use large speech models and next-generation models, the service can return transcriptions more quickly and also provide noticeably better transcription accuracy.
You specify a large speech model or next-generation model by using the `model` query parameter, as you do a previous-generation model. Only the next-generation models support the `low_latency` parameter, and all large speech models and next-generation models support the `character_insertion_bias` parameter. These parameters are not available with previous-generation models.
Large speech models and next-generation models do not support all of the speech recognition parameters that are available for use with previous-generation models. Next-generation models do not support the following parameters:
- `acoustic_customization_id`
- `keywords` and `keywords_threshold`
- `processing_metrics` and `processing_metrics_interval`
- `word_alternatives_threshold`
Important: Effective 31 July 2023, all previous-generation models will be removed from the service and the documentation. Most previous-generation models were deprecated on 15 March 2022. You must migrate to the equivalent large speech model or next-generation model by 31 July 2023. For more information, see Migrating to large speech models.
See also:
- Large speech languages and models
- Supported features for large speech models
- Next-generation languages and models
- Supported features for next-generation models
Request
Request Body
Path Parameters
Query Parameters
model
string
The model to use for speech recognition. If you omit the `model` parameter, the service uses the US English `en-US_BroadbandModel` by default.
For IBM Cloud Pak for Data, if you do not install the `en-US_BroadbandModel`, you must either specify a model with the request or specify a new default model for your installation of the service.
See also:
callback_url
string
A URL to which callback notifications are to be sent. The URL must already be successfully allowlisted by using the Register a callback method. You can include the same callback URL with any number of job creation requests. Omit the parameter to poll the service for job completion and results.
Use the `user_token` parameter to specify a unique user-specified string with each job to differentiate the callback notifications for the jobs.
events
string
If the job includes a callback URL, a comma-separated list of notification events to which to subscribe. Valid events are
- `recognitions.started` generates a callback notification when the service begins to process the job.
- `recognitions.completed` generates a callback notification when the job is complete. You must use the Check a job method to retrieve the results before they time out or are deleted.
- `recognitions.completed_with_results` generates a callback notification when the job is complete. The notification includes the results of the request.
- `recognitions.failed` generates a callback notification if the service experiences an error while processing the job.
The `recognitions.completed` and `recognitions.completed_with_results` events are incompatible. You can specify only of the two events.
If the job includes a callback URL, omit the parameter to subscribe to the default events: `recognitions.started`, `recognitions.completed`, and `recognitions.failed`. If the job does not include a callback URL, omit the parameter.
user_token
string
If the job includes a callback URL, a user-specified string that the service is to include with each callback notification for the job; the token allows the user to maintain an internal mapping between jobs and notification events. If the job does not include a callback URL, omit the parameter.
results_ttl
integer
The number of minutes for which the results are to be available after the job has finished. If not delivered via a callback, the results must be retrieved within this time. Omit the parameter to use a time to live of one week. The parameter is valid with or without a callback URL.
speech_begin_event
boolean
If `true`, the service returns a response object `SpeechActivity` which contains the time when a speech activity is detected in the stream. This can be used both in standard and low latency mode. This feature enables client applications to know that some words/speech has been detected and the service is in the process of decoding. This can be used in lieu of interim results in standard mode. Use `sad_module: 2` to increase accuracy and performance in detecting speech boundaries within the audio stream. See Using speech recognition parameters
enrichments
string
Speech transcript enrichment improves readability of raw ASR transcripts by adding punctuation (periods, commas, question marks, exclamation points) and intelligent capitalization (sentence beginnings, proper nouns, acronyms, brand names). To enable enrichment, add the `enrichments=punctuation` parameter to your recognition request. Supported languages include English (US, UK, Australia, India), French (France, Canada), German, Italian, Portuguese (Brazil, Portugal), Spanish (Spain, Latin America, Argentina, Chile, Colombia, Mexico, Peru), and Japanese. See Speech transcript enrichment.
language_customization_id
string
The customization ID (GUID) of a custom language model that is to be used with the recognition request. The base model of the specified custom language model must match the model specified with the `model` parameter. You must make the request with credentials for the instance of the service that owns the custom model. By default, no custom language model is used. See Using a custom language model for speech recognition.
Note: Use this parameter instead of the deprecated `customization_id` parameter.
acoustic_customization_id
string
The customization ID (GUID) of a custom acoustic model that is to be used with the recognition request. The base model of the specified custom acoustic model must match the model specified with the `model` parameter. You must make the request with credentials for the instance of the service that owns the custom model. By default, no custom acoustic model is used. See Using a custom acoustic model for speech recognition.
base_model_version
string
The version of the specified base model that is to be used with the recognition request. Multiple versions of a base model can exist when a model is updated for internal improvements. The parameter is intended primarily for use with custom models that have been upgraded for a new base model. The default value depends on whether the parameter is used with or without a custom model. See Making speech recognition requests with upgraded custom models.
customization_weight
number
If you specify the customization ID (GUID) of a custom language model with the recognition request, the customization weight tells the service how much weight to give to words from the custom language model compared to those from the base model for the current request.
Specify a value between 0.0 and 1.0. Unless a different customization weight was specified for the custom model when the model was trained, the default value is:
- 0.5 for large speech models
- 0.3 for previous-generation models
- 0.2 for most next-generation models
- 0.1 for next-generation English and Japanese models
A customization weight that you specify overrides a weight that was specified when the custom model was trained. The default value yields the best performance in general. Assign a higher value if your audio makes frequent use of OOV words from the custom model. Use caution when setting the weight: a higher value can improve the accuracy of phrases from the custom model's domain, but it can negatively affect performance on non-domain phrases.
See Using customization weight.
inactivity_timeout
integer
The time in seconds after which, if only silence (no speech) is detected in streaming audio, the connection is closed with a 400 error. The parameter is useful for stopping audio submission from a live microphone when a user simply walks away. Use `-1` for infinity. See Inactivity timeout.
keywords
array
An array of keyword strings to spot in the audio. Each keyword string can include one or more string tokens. Keywords are spotted only in the final results, not in interim hypotheses. If you specify any keywords, you must also specify a keywords threshold. Omit the parameter or specify an empty array if you do not need to spot keywords.
You can spot a maximum of 1000 keywords with a single request. A single keyword can have a maximum length of 1024 characters, though the maximum effective length for double-byte languages might be shorter. Keywords are case-insensitive.
See Keyword spotting.
keywords_threshold
number
A confidence value that is the lower bound for spotting a keyword. A word is considered to match a keyword if its confidence is greater than or equal to the threshold. Specify a probability between 0.0 and 1.0. If you specify a threshold, you must also specify one or more keywords. The service performs no keyword spotting if you omit either parameter. See Keyword spotting.
max_alternatives
integer
The maximum number of alternative transcripts that the service is to return. By default, the service returns a single transcript. If you specify a value of `0`, the service uses the default value, `1`. See Maximum alternatives.
word_alternatives_threshold
number
A confidence value that is the lower bound for identifying a hypothesis as a possible word alternative (also known as "Confusion Networks"). An alternative word is considered if its confidence is greater than or equal to the threshold. Specify a probability between 0.0 and 1.0. By default, the service computes no alternative words. See Word alternatives.
word_confidence
boolean
If `true`, the service returns a confidence measure in the range of 0.0 to 1.0 for each word. By default, the service returns no word confidence scores. See Word confidence.
timestamps
boolean
If `true`, the service returns time alignment for each word. By default, no timestamps are returned. See Word timestamps.
profanity_filter
boolean
If `true`, the service filters profanity from all output except for keyword results by replacing inappropriate words with a series of asterisks. Set the parameter to `false` to return results with no censoring.
Note: The parameter can be used with US English and Japanese transcription only. See Profanity filtering.
smart_formatting
boolean
If `true`, the service converts dates, times, series of digits and numbers, phone numbers, currency values, and internet addresses into more readable, conventional representations in the final transcript of a recognition request. For US English, the service also converts certain keyword strings to punctuation symbols. By default, the service performs no smart formatting.
Note: The parameter can be used with US English, Japanese, and Spanish (all dialects) transcription only.
See Smart formatting.
smart_formatting_version
integer
Smart formatting version for large speech models and next-generation models is supported in US English, Brazilian Portuguese, French, German, Spanish and French Canadian languages.
speaker_labels
boolean
If `true`, the response includes labels that identify which words were spoken by which participants in a multi-person exchange. By default, the service returns no speaker labels. Setting `speaker_labels` to `true` forces the `timestamps` parameter to be `true`, regardless of whether you specify `false` for the parameter.
- For previous-generation models, the parameter can be used with Australian English, US English, German, Japanese, Korean, and Spanish (both broadband and narrowband models) and UK English (narrowband model) transcription only.
- For large speech models and next-generation models, the parameter can be used with all available languages.
See Speaker labels.
grammar_name
string
The name of a grammar that is to be used with the recognition request. If you specify a grammar, you must also use the `language_customization_id` parameter to specify the name of the custom language model for which the grammar is defined. The service recognizes only strings that are recognized by the specified grammar; it does not recognize other custom words from the model's words resource.
See Using a grammar for speech recognition.
redaction
boolean
If `true`, the service redacts, or masks, numeric data from final transcripts. The feature redacts any number that has three or more consecutive digits by replacing each digit with an `X` character. It is intended to redact sensitive numeric data, such as credit card numbers. By default, the service performs no redaction.
When you enable redaction, the service automatically enables smart formatting, regardless of whether you explicitly disable that feature. To ensure maximum security, the service also disables keyword spotting (ignores the `keywords` and `keywords_threshold` parameters) and returns only a single final transcript (forces the `max_alternatives` parameter to be `1`).
Note: The parameter can be used with US English, Japanese, and Korean transcription only.
See Numeric redaction.
processing_metrics
boolean
If `true`, requests processing metrics about the service's transcription of the input audio. The service returns processing metrics at the interval specified by the `processing_metrics_interval` parameter. It also returns processing metrics for transcription events, for example, for final and interim results. By default, the service returns no processing metrics.
See Processing metrics.
processing_metrics_interval
number
Specifies the interval in real wall-clock seconds at which the service is to return processing metrics. The parameter is ignored unless the `processing_metrics` parameter is set to `true`.
The parameter accepts a minimum value of 0.1 seconds. The level of precision is not restricted, so you can specify values such as 0.25 and 0.125.
The service does not impose a maximum value. If you want to receive processing metrics only for transcription events instead of at periodic intervals, set the value to a large number. If the value is larger than the duration of the audio, the service returns processing metrics only for transcription events.
See Processing metrics.
audio_metrics
boolean
If `true`, requests detailed information about the signal characteristics of the input audio. The service returns audio metrics with the final transcription results. By default, the service returns no audio metrics.
See Audio metrics.
end_of_phrase_silence_time
number
Specifies the duration of the pause interval at which the service splits a transcript into multiple final results. If the service detects pauses or extended silence before it reaches the end of the audio stream, its response can include multiple final results. Silence indicates a point at which the speaker pauses between spoken words or phrases.
Specify a value for the pause interval in the range of 0.0 to 120.0.
- A value greater than 0 specifies the interval that the service is to use for speech recognition.
- A value of 0 indicates that the service is to use the default interval. It is equivalent to omitting the parameter.
The default pause interval for most languages is 0.8 seconds; the default for Chinese is 0.6 seconds.
See End of phrase silence time.
split_transcript_at_phrase_end
boolean
If `true`, directs the service to split the transcript into multiple final results based on semantic features of the input, for example, at the conclusion of meaningful phrases such as sentences. The service bases its understanding of semantic features on the base language model that you use with a request. Custom language models and grammars can also influence how and where the service splits a transcript.
By default, the service splits transcripts based solely on the pause interval. If the parameters are used together on the same request, `end_of_phrase_silence_time` has precedence over `split_transcript_at_phrase_end`.
See Split transcript at phrase end.
speech_detector_sensitivity
number
The sensitivity of speech activity detection that the service is to perform. Use the parameter to suppress word insertions from music, coughing, and other non-speech events. The service biases the audio it passes for speech recognition by evaluating the input audio against prior models of speech and non-speech activity.
Specify a value between 0.0 and 1.0:
- 0.0 suppresses all audio (no speech is transcribed).
- 0.5 (the default) provides a reasonable compromise for the level of sensitivity.
- 1.0 suppresses no audio (speech detection sensitivity is disabled).
The values increase on a monotonic curve. Specifying one or two decimal places of precision (for example, `0.55`) is typically more than sufficient.
The parameter is supported with all large speech models, next-generation models and with most previous-generation models. See Speech detector sensitivity and Language model support.
sad_module
integer
Detects speech boundaries within the audio stream with better performance, improved noise suppression, faster responsiveness, and increased accuracy.
Specify `sad_module: 2`
See Speech Activity Detection (SAD).
background_audio_suppression
number
The level to which the service is to suppress background audio based on its volume to prevent it from being transcribed as speech. Use the parameter to suppress side conversations or background noise.
Specify a value in the range of 0.0 to 1.0:
- 0.0 (the default) provides no suppression (background audio suppression is disabled).
- 0.5 provides a reasonable level of audio suppression for general usage.
- 1.0 suppresses all audio (no audio is transcribed).
The values increase on a monotonic curve. Specifying one or two decimal places of precision (for example, `0.55`) is typically more than sufficient.
The parameter is supported with all large speech models, next-generation models and with most previous-generation models. See Background audio suppression and Language model support.
low_latency
boolean
If `true` for next-generation `Multimedia` and `Telephony` models that support low latency, directs the service to produce results even more quickly than it usually does. Next-generation models produce transcription results faster than previous-generation models. The `low_latency` parameter causes the models to produce results even more quickly, though the results might be less accurate when the parameter is used.
The parameter is not available for large speech models and previous-generation `Broadband` and `Narrowband` models. It is available for most next-generation models.
- For a list of next-generation models that support low latency, see Supported next-generation language models.
- For more information about the `low_latency` parameter, see Low latency.
character_insertion_bias
number
For large speech models and next-generation models, an indication of whether the service is biased to recognize shorter or longer strings of characters when developing transcription hypotheses. By default, the service is optimized to produce the best balance of strings of different lengths.
The default bias is 0.0. The allowable range of values is -1.0 to 1.0.
- Negative values bias the service to favor hypotheses with shorter strings of characters.
- Positive values bias the service to favor hypotheses with longer strings of characters.
As the value approaches -1.0 or 1.0, the impact of the parameter becomes more pronounced. To determine the most effective value for your scenario, start by setting the value of the parameter to a small increment, such as -0.1, -0.05, 0.05, or 0.1, and assess how the value impacts the transcription results. Then experiment with different values as necessary, adjusting the value by small increments.
The parameter is not available for previous-generation models.
Response
201 - Created. The job was successfully created.
id
string
The ID of the asynchronous job.
status
string
The current status of the job:
- `waiting`: The service is preparing the job for processing. The service returns this status when the job is initially created or when it is waiting for capacity to process the job. The job remains in this state until the service has the capacity to begin processing it.
- `processing`: The service is actively processing the job.
- `completed`: The service has finished processing the job. If the job specified a callback URL and the event `recognitions.completed_with_results`, the service sent the results with the callback notification. Otherwise, you must retrieve the results by checking the individual job.
- `failed`: The job failed.
created
string
The date and time in Coordinated Universal Time (UTC) at which the job was created. The value is provided in full ISO 8601 format (`YYYY-MM-DDThh:mm:ss.sTZD`).
updated
string
The date and time in Coordinated Universal Time (UTC) at which the job was last updated by the service. The value is provided in full ISO 8601 format (`YYYY-MM-DDThh:mm:ss.sTZD`). This field is returned only by the Check jobs and [Check a job[(#checkjob) methods.
url
string
The URL to use to request information about the job with the Check a job method. This field is returned only by the Create a job method.
user_token
string
The user token associated with a job that was created with a callback URL and a user token. This field can be returned only by the Check jobs method.
results
array
If the status is `completed`, the results of the recognition request as an array that includes a single instance of a `SpeechRecognitionResults` object. This field is returned only by the Check a job method.
warnings
array
An array of warning messages about invalid parameters included with the request. Each warning includes a descriptive message and a list of invalid argument strings, for example, `"unexpected query parameter 'user_token', query parameter 'callback_url' was not specified"`. The request succeeds despite the warnings. This field can be returned only by the Create a job method. (If you use the `character_insertion_bias` parameter with a previous-generation model, the warning message refers to the parameter as `lambdaBias`.)
400 - Bad Request. The request failed because of a user input error. For example, the request passed audio that does not match the indicated format or failed to specify a required audio format; specified a custom language or custom acoustic model that is not in the `available` state; or specified both the `recognitions.completed` and `recognitions.completed_with_results` events. Specific messages include
- `Model {model} not found`
- `Requested model is not available`
- `This 8000hz audio input requires a narrow band model. See /v1/models for a list of available models.`
- `speaker_labels is not a supported feature for model {model}`
- `keywords_threshold value must be between zero and one (inclusive)`
- `word_alternatives_threshold value must be between zero and one (inclusive)`
- `You cannot specify both 'customization_id' and 'language_customization_id' parameter!`
- `No speech detected for 30s`
- `Unable to transcode data stream application/octet-stream -> audio/l16`
- `Stream was {number} bytes but needs to be at least 100 bytes.`
- `keyword {keyword} length exceeds the maximum length 1024`
- `low_latency is not a supported feature for model {model}`
- `Character insertion bias must be a value between -1 and 1.`
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
404 - Not Found. The specified model does not exist or, for IBM Cloud Pak for Data, the `model` parameter was not specified but the default model is not installed. The message is `Model '{model}' not found`.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
500 - Internal Server Error. The service experienced an internal error.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
503 - Service Unavailable. The service is currently unavailable.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
Check jobs
GET /v1/recognitions
Returns the ID and status of the latest 100 outstanding jobs associated with the credentials with which it is called. The method also returns the creation and update times of each job, and, if a job was created with a callback URL and a user token, the user token for the job. To obtain the results for a job whose status is `completed` or not one of the latest 100 outstanding jobs, use the [Check a job[(#checkjob) method. A job and its results remain available until you delete them with the Delete a job method or until the job's time to live expires, whichever comes first.
See also: Checking the status of the latest jobs.
Request
Response
200 - OK. The request succeeded.
recognitions
array
An array of `RecognitionJob` objects that provides the status for each of the user's current jobs. The array is empty if the user has no current jobs.
500 - Internal Server Error. The service experienced an internal error.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
503 - Service Unavailable. The service is currently unavailable.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
See also: Checking the status and retrieving the results of a job.">
Check a job
GET /v1/recognitions/{id}
Returns information about the specified job. The response always includes the status of the job and its creation and update times. If the status is `completed`, the response includes the results of the recognition request. You must use credentials for the instance of the service that owns a job to list information about it.
You can use the method to retrieve the results of any job, regardless of whether it was submitted with a callback URL and the `recognitions.completed_with_results` event, and you can retrieve the results multiple times for as long as they remain available. Use the Check jobs method to request information about the most recent jobs associated with the calling credentials.
See also: Checking the status and retrieving the results of a job.
Request
Path Parameters
id
Required *
string
The identifier of the asynchronous job that is to be used for the request. You must make the request with credentials for the instance of the service that owns the job.
Query Parameters
Response
200 - OK. The request succeeded.
id
string
The ID of the asynchronous job.
status
string
The current status of the job:
- `waiting`: The service is preparing the job for processing. The service returns this status when the job is initially created or when it is waiting for capacity to process the job. The job remains in this state until the service has the capacity to begin processing it.
- `processing`: The service is actively processing the job.
- `completed`: The service has finished processing the job. If the job specified a callback URL and the event `recognitions.completed_with_results`, the service sent the results with the callback notification. Otherwise, you must retrieve the results by checking the individual job.
- `failed`: The job failed.
created
string
The date and time in Coordinated Universal Time (UTC) at which the job was created. The value is provided in full ISO 8601 format (`YYYY-MM-DDThh:mm:ss.sTZD`).
updated
string
The date and time in Coordinated Universal Time (UTC) at which the job was last updated by the service. The value is provided in full ISO 8601 format (`YYYY-MM-DDThh:mm:ss.sTZD`). This field is returned only by the Check jobs and [Check a job[(#checkjob) methods.
url
string
The URL to use to request information about the job with the Check a job method. This field is returned only by the Create a job method.
user_token
string
The user token associated with a job that was created with a callback URL and a user token. This field can be returned only by the Check jobs method.
results
array
If the status is `completed`, the results of the recognition request as an array that includes a single instance of a `SpeechRecognitionResults` object. This field is returned only by the Check a job method.
warnings
array
An array of warning messages about invalid parameters included with the request. Each warning includes a descriptive message and a list of invalid argument strings, for example, `"unexpected query parameter 'user_token', query parameter 'callback_url' was not specified"`. The request succeeds despite the warnings. This field can be returned only by the Create a job method. (If you use the `character_insertion_bias` parameter with a previous-generation model, the warning message refers to the parameter as `lambdaBias`.)
404 - Not Found. The specified job ID was not found.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
500 - Internal Server Error. The service experienced an internal error.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
503 - Service Unavailable. The service is currently unavailable.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
Delete a job
DELETE /v1/recognitions/{id}
Deletes the specified job. You cannot delete a job that the service is actively processing. Once you delete a job, its results are no longer available. The service automatically deletes a job and its results when the time to live for the results expires. You must use credentials for the instance of the service that owns a job to delete it.
See also: Deleting a job.
Request
Path Parameters
id
Required *
string
The identifier of the asynchronous job that is to be used for the request. You must make the request with credentials for the instance of the service that owns the job.
Query Parameters
Response
204 - No Content. The job was successfully deleted.
400 - Bad Request. The service cannot delete a job that it is actively processing:
- `Unable to delete the processing job`
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
404 - Not Found. The specified job ID was not found.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
500 - Internal Server Error. The service experienced an internal error.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
503 - Service Unavailable. The service is currently unavailable.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
See also:
Large speech models and Next-generation models
The service supports large speech models and next-generation `Multimedia` (16 kHz) and `Telephony` (8 kHz) models for many languages. Large speech models and next-generation models have higher throughput than the service's previous generation of `Broadband` and `Narrowband` models. When you use large speech models and next-generation models, the service can return transcriptions more quickly and also provide noticeably better transcription accuracy.
You specify a large speech model or next-generation model by using the `model` query parameter, as you do a previous-generation model. Only the next-generation models support the `low_latency` parameter, and all large speech models and next-generation models support the `character_insertion_bias` parameter. These parameters are not available with previous-generation models.
Large speech models and next-generation models do not support all of the speech recognition parameters that are available for use with previous-generation models. Next-generation models do not support the following parameters:
- `acoustic_customization_id`
- `keywords` and `keywords_threshold`
- `processing_metrics` and `processing_metrics_interval`
- `word_alternatives_threshold`
Important: Effective 31 July 2023, all previous-generation models will be removed from the service and the documentation. Most previous-generation models were deprecated on 15 March 2022. You must migrate to the equivalent large speech model or next-generation model by 31 July 2023. For more information, see Migrating to large speech models.
See also:
- Large speech languages and models
- Supported features for large speech models
- Next-generation languages and models
- Supported features for next-generation models">
Create a custom language model
POST /v1/customizations
Creates a new custom language model for a specified base model. The custom language model can be used only with the base model for which it is created. The model is owned by the instance of the service whose credentials are used to create it.
You can create a maximum of 1024 custom language models per owning credentials. The service returns an error if you attempt to create more than 1024 models. You do not lose any models, but you cannot create any more until your model count is below the limit.
Important: Effective 31 July 2023, all previous-generation models will be removed from the service and the documentation. Most previous-generation models were deprecated on 15 March 2022. You must migrate to the equivalent large speech model or next-generation model by 31 July 2023. For more information, see Migrating to large speech models.
See also:
Large speech models and Next-generation models
The service supports large speech models and next-generation `Multimedia` (16 kHz) and `Telephony` (8 kHz) models for many languages. Large speech models and next-generation models have higher throughput than the service's previous generation of `Broadband` and `Narrowband` models. When you use large speech models and next-generation models, the service can return transcriptions more quickly and also provide noticeably better transcription accuracy.
You specify a large speech model or next-generation model by using the `model` query parameter, as you do a previous-generation model. Only the next-generation models support the `low_latency` parameter, and all large speech models and next-generation models support the `character_insertion_bias` parameter. These parameters are not available with previous-generation models.
Large speech models and next-generation models do not support all of the speech recognition parameters that are available for use with previous-generation models. Next-generation models do not support the following parameters:
- `acoustic_customization_id`
- `keywords` and `keywords_threshold`
- `processing_metrics` and `processing_metrics_interval`
- `word_alternatives_threshold`
Important: Effective 31 July 2023, all previous-generation models will be removed from the service and the documentation. Most previous-generation models were deprecated on 15 March 2022. You must migrate to the equivalent large speech model or next-generation model by 31 July 2023. For more information, see Migrating to large speech models.
See also:
- Large speech languages and models
- Supported features for large speech models
- Next-generation languages and models
- Supported features for next-generation models
Request
Request Body
CreateLanguageModel
A `CreateLanguageModel` object that provides basic information about the new custom language model.
name
Required *
string
A user-defined name for the new custom language model. Use a localized name that matches the language of the custom model. Use a name that describes the domain of the custom model, such as `Medical custom model` or `Legal custom model`. Use a name that is unique among all custom language models that you own.
Include a maximum of 256 characters in the name. Do not use backslashes, slashes, colons, equal signs, ampersands, or question marks in the name.
base_model_name
Required *
string
The name of the base language model that is to be customized by the new custom language model. The new custom model can be used only with the base model that it customizes.
To determine whether a base model supports language model customization, use the Get a model method and check that the attribute `custom_language_model` is set to `true`. You can also refer to Language support for customization.
dialect
string
The dialect of the specified language that is to be used with the custom language model. For all languages, it is always safe to omit this field. The service automatically uses the language identifier from the name of the base model. For example, the service automatically uses `en-US` for all US English models.
If you specify the `dialect` for a new custom model, follow these guidelines. For non-Spanish previous-generation models and for next-generation models, you must specify a value that matches the five-character language identifier from the name of the base model. For Spanish previous-generation models, you must specify one of the following values:
- `es-ES` for Castilian Spanish (`es-ES` models)
- `es-LA` for Latin American Spanish (`es-AR`, `es-CL`, `es-CO`, and `es-PE` models)
- `es-US` for Mexican (North American) Spanish (`es-MX` models)
All values that you pass for the `dialect` field are case-insensitive.
description
string
A recommended description of the new custom language model. Use a localized description that matches the language of the custom model. Include a maximum of 128 characters in the description.
Response
201 - Created. The custom language model was successfully created.
customization_id
string
The customization ID (GUID) of the custom language model. The Create a custom language model method returns only this field of the object; it does not return the other fields.
created
string
The date and time in Coordinated Universal Time (UTC) at which the custom language model was created. The value is provided in full ISO 8601 format (`YYYY-MM-DDThh:mm:ss.sTZD`).
updated
string
The date and time in Coordinated Universal Time (UTC) at which the custom language model was last modified. The `created` and `updated` fields are equal when a language model is first added but has yet to be updated. The value is provided in full ISO 8601 format (YYYY-MM-DDThh:mm:ss.sTZD).
language
string
The language identifier of the custom language model (for example, `en-US`). The value matches the five-character language identifier from the name of the base model for the custom model. This value might be different from the value of the `dialect` field.
dialect
string
The dialect of the language for the custom language model. For custom models that are based on non-Spanish previous-generation models and on next-generation models, the field matches the language of the base model; for example, `en-US` for one of the US English models. For custom models that are based on Spanish previous-generation models, the field indicates the dialect with which the model was created. The value can match the name of the base model or, if it was specified by the user, can be one of the following:
- `es-ES` for Castilian Spanish (`es-ES` models)
- `es-LA` for Latin American Spanish (`es-AR`, `es-CL`, `es-CO`, and `es-PE` models)
- `es-US` for Mexican (North American) Spanish (`es-MX` models)
Dialect values are case-insensitive.
versions
array
A list of the available versions of the custom language model. Each element of the array indicates a version of the base model with which the custom model can be used. Multiple versions exist only if the custom model has been upgraded to a new version of its base model. Otherwise, only a single version is shown.
owner
string
The GUID of the credentials for the instance of the service that owns the custom language model.
name
string
The name of the custom language model.
description
string
The description of the custom language model.
base_model_name
string
The name of the language model for which the custom language model was created.
status
string
The current status of the custom language model:
- `pending`: The model was created but is waiting either for valid training data to be added or for the service to finish analyzing added data.
- `ready`: The model contains valid data and is ready to be trained. If the model contains a mix of valid and invalid resources, you need to set the `strict` parameter to `false` for the training to proceed.
- `training`: The model is currently being trained.
- `available`: The model is trained and ready to use.
- `upgrading`: The model is currently being upgraded.
- `failed`: Training of the model failed.
progress
integer
A percentage that indicates the progress of the custom language model's current training. A value of `100` means that the model is fully trained. Note: The `progress` field does not currently reflect the progress of the training. The field changes from `0` to `100` when training is complete.
error
string
If an error occurred while adding a grammar file to the custom language model, a message that describes an `Internal Server Error` and includes the string `Cannot compile grammar`. The status of the custom model is not affected by the error, but the grammar cannot be used with the model.
warnings
string
If the request included unknown parameters, the following message: `Unexpected query parameter(s) ['parameters'] detected`, where `parameters` is a list that includes a quoted string for each unknown parameter.
400 - Bad Request. A required parameter is null or invalid. Specific failure messages include:
- `Required parameter '{name}' is missing`
- `Required parameter '{name}' cannot be empty string`
- `Required parameter '{name}' cannot be null`
- `The base model '{model_name}' is not recognized`
- `Language customization is not supported for base model '{model_name}'`
- `Invalid dialect value '{dialect}' specified for language '{language}'`
- `You exceeded the maximum '{model_number}' of allowed custom language models. You have '{model_number}' custom language models. Please remove the models you do not need or contact the IBM speech support team to apply for an exception.`
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
401 - Unauthorized. The specified credentials are invalid.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
500 - Internal Server Error. The service experienced an internal error.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
503 - Service Unavailable. The service is currently unavailable.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
List custom language models
GET /v1/customizations
Lists information about all custom language models that are owned by an instance of the service. Use the `language` parameter to see all custom language models for the specified language. Omit the parameter to see all custom language models for all languages. You must use credentials for the instance of the service that owns a model to list information about it.
See also:
Request
Path Parameters
Query Parameters
language
string
The identifier of the language for which custom language or custom acoustic models are to be returned. Specify the five-character language identifier; for example, specify `en-US` to see all custom language or custom acoustic models that are based on US English models. Omit the parameter to see all custom language or custom acoustic models that are owned by the requesting credentials.
To determine the languages for which customization is available, see Language support for customization.
Response
200 - OK. The request succeeded.
customizations
array
An array of `LanguageModel` objects that provides information about each available custom language model. The array is empty if the requesting credentials own no custom language models (if no language is specified) or own no custom language models for the specified language.
400 - Bad Request. A required parameter is null or invalid. Specific failure messages include:
- `Language '{language}' is not supported for customization`.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
401 - Unauthorized. The specified credentials are invalid.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
500 - Internal Server Error. The service experienced an internal error.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
503 - Service Unavailable. The service is currently unavailable.
error
string
Description of the problem.
code
integer
HTTP response code.
code_description
string
Response message.
warnings
array
Warnings associated with the error.
Get a custom language model
GET /v1/customizations/{customization_id}
Gets information about a specified custom language model. You must use credentials for the instance of the service that owns a model to list information about it.
See also:
Request
Path Parameters
customization_id
Required *
string
The customization ID (GUID) of the custom language model that is to be used for the request. You must make the request with credentials for the instance of the service that owns the custom model.
Query Parameters
Response
200 - OK. The request succeeded.
customization_id
string
The customization ID (GUID) of the custom language model. The Create a custom language model method returns only this field of the object; it does not return the other fields.
created
string
The date and time in Coordinated Universal Time (UTC) at which the custom language model was created. The value is provided in full ISO 8601 format (`YYYY-MM-DDThh:mm:ss.sTZD`).
updated
string
The date and time in Coordinated Universal Time (UTC) at which the custom language model was last modified. The `created` and `updated` fields are equal when a language model is first added but has yet to be updated. The value is provided in full ISO 8601 format (YYYY-MM-DDThh:mm:ss.sTZD).
language
string
The language identifier of the custom language model (for example, `en-US`). The value matches the five-character language identifier from the name of the base model for the custom model. This value might be different from the value of the `dialect` field.
dialect
string
[...]
